#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "Odds2_Room.h"
#include "FileEncrypt.h"
std::auto_ptr<Odds2_Room> Odds2_Room::msSingleton(nullptr);

int Odds2_Room::GetCount()
{
	return (int)mMapData.size();
}

const Odds2_RoomData* Odds2_Room::GetData(int RoomID)
{
	auto it = mMapData.find(RoomID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, Odds2_RoomData>& Odds2_Room::GetMapData()
{
	return mMapData;
}

void Odds2_Room::Reload()
{
	mMapData.clear();
	Load();
}

void Odds2_Room::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Odds2_RoomData data;
		data.mRoomID = element->IntAttribute("RoomID");
		data.mLaserAdd = element->IntAttribute("LaserAdd");
		data.mLaserReduce = element->IntAttribute("LaserReduce");
		data.mFormationAdd = element->IntAttribute("FormationAdd");
		data.mFormationReduce = element->IntAttribute("FormationReduce");
		if (mMapData.find(data.mRoomID) != mMapData.end())std::cout <<"data refind:" << data.mRoomID << std::endl;
		assert(mMapData.find(data.mRoomID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mRoomID, data));
		element = element->NextSiblingElement();
	}
}

void Odds2_Room::Load()
{
	Load("../Config/Odds2_Room.xml");
}

Odds2_Room* Odds2_Room::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Odds2_Room());
	}
	return msSingleton.get();
}
